function A=pivot(x,y,r,N)

% Cette fonction suit la mthode du pivot de Gauss, afin de dterminer les
% coefficients a(i) de la modlisation.
% Elle prend en charge la gestion d'un pivot trop faible.

test=1;
M=matrice(x,y,N,r);
for i=1:r+1    
    % Vrification de la valeur du pivot
    if (abs(M(i,i))<=eps)
        disp('Problme sur le pivot, possibilit de permuter deux lignes en cours d''tude...')
        indice=i;
        
        % Recherche d'un pivot plus adquat
        while ((abs(M(indice,i))<=eps)&&(indice<r+2))
            indice=indice+1;
        end
        
        % Recherche ngative aprs vrification de toutes les lignes
        if (indice==r+2)
            test=0;
        else
            disp('permutligne') 
            M=permutligne(r,i,indice,M);  % Permutation de la ligne avec celle du pivot trouv
        end
    end
 
    % Mthode de Gauss sur la matrice
    
    if (test==1)
        for j=i+1:r+2
            % Division de la ligne par le pivot
            M(i,j)=M(i,j)/M(i,i);
        end
        M(i,i)=1;    
        % Pivot mis  1
        for indice=1:r+1
            if (indice~=i)
                coeff=M(indice,i);
                for j=1:r+2
                    % Annulation des termes autres que le pivot sur la colonne
                    M(indice,j)=M(indice,j)-coeff*M(i,j);
                    
                end
            end
        end
    end

end

% Cration de la matrice A, contenant les coefficients du polynme
if (test==1)
    for i=1:r+1
        A(i)=M(i,r+2);
    end
else 
    disp('Erreur de prcision sur le pivot')
end

end

    
        
        