disp(' ')
disp('               ]>AJUSTEMENT POLYNOMIAL<[')
disp('  ')
disp('Forme canonique : a0+a1.x^1+a2.x^2+...+an.x^n')
disp(' ')
disp('Ce programme vous permet d''importer des donner aux formats texte')
disp('ou excel. Crez un fichier nomm valeurs.(extension : .txt/.xls)')
disp('dans la racine du disque c (c:\valeurs.txt/xls).')
disp(' ')
r=input('Entrez le degr du polynme pour l''ajustement polynomial : ');

rep=input('Quel format de fichier voulez vous lire ? texte (.txt) ou excel (.xls) ?  (t/e)  ','s');

if rep=='t' % Procdure fichier texte
   
    % Ouverture du fichier de valeurs exprimentales
    fid=fopen('c:\valeurs.txt','r');
    data=fscanf(fid,'%f%f',[2 inf]);
    fclose(fid);

    % Transpose de la matrice data pour les traitements qui suivent
    data=data';

    % Dtermination du nombre de valeurs
    N=size(data,1);

    % Cration des vecteurs x et y
    x=data(:,1);
    y=data(:,2);
else % Procdure fichier Excel
    data = xlsread('c:\valeurs'); % data prend les valeurs du fichier excel
    x=data(:,1); % Cration des vecteurs x et y
    y=data(:,2);
    N=size(data,1); % Dtermination du nombre de valeurs
end

% Cration du vecteur A contenant les coefficients du polynme
A=pivot(x,y,r,N);

% Cration du chane de caractre "pol", qui contiendra l'expression de
% coefficients du polynme et les x  la puissance correspondante.
pol=(['y = ',num2str(A(1))]); % Dbut de la chane de caractre, pour tous les cas.
for i=1:r
    if A(i+1)<0 % But de la boucle : viter d'afficher " + -a(i)"
        pui=([' ',num2str(A(i+1)),'.x^',num2str(i)]); % Chane tampon "pui", contenant le terme  ajouter, pour coefficient ngatif
    else
        pui=([' +',num2str(A(i+1)),'.x^',num2str(i)]); % Chane tampon "pui", contenant le terme  ajouter, pour coefficient positif
    end
    pol=strcat(pol,pui); % Concatnation de "pui"  la suite de "pol"
end

disp(' ')
disp('Rsultats de la modlisation :')
disp(pol)

% Calcul de ym (y moyen)
ym=moyenne(y,N);

% Calcul de ymc (y moindres carrs) de l'ajustement pour chaque valeurs exprimentales x
ymc=g(A,x,r);

% Calcul des trois sommes relatives aux carts entre valeurs relles,
% mesures et calcules.
Se=som_expl(ymc,ym,N);
St=som_tot(y,ym,N);
Sr=som_res(y,ymc,N);

disp('  ')
r2=determination(Se,St);
% Affichage des coefficients montrant la qualit de l'ajustement
disp(['Le coefficient de dtermination r est ',num2str(r2),'.'])

vr=var_res(Sr,N,r);
ve=var_expl(Se,r);
F=facteur(vr,ve);

disp(['Le facteur de qualit F est ',num2str(F),'.'])
disp(' ')
    
% Affichage des courbes exprimentales et ajustes
graphiques

% Proposition d'aide sur les facteurs de qualit
rep=input('Voulez-vous de l''aide sur ces coefficients ? o/n ','s');
if isempty(rep),rep='n'; end % Taper entre revient  dire non. On considre l'aide comme secondaire
if rep=='o'
    disp('Plus l''ajustement est correct, plus r tend vers 1, et plus F tend vers l''infini.')
end
disp(' ')

% Proposition d'une tude statistique
rep=input('Dsirez vous connatre les incertitudes sur les coefficients ? o/n ','s');
if isempty(rep),rep='o'; end % Taper entre revient ici  dire oui.
if rep=='o'
    varcovar(x,N,r,Sr,A)
end
