function I=simpsonV(a,b,n)

% simpsonV renvoie le rsultat de l'intgrale _/dV/V, entre a et b

n=2*n; %pour avoir un nb de pas pair
h=(b-a)/n; % longueur de l'intervalle lmentaire

% Calcul du terme intgral partiel
somme=inV(a)+inV(b);
for i=1:2:n-3
    somme=somme+4*inV(a+i*h)+2*inV(a+(i+1)*h);
end
somme=somme+inV(a+(n-1)*h); % Addition du terme rsiduel hors-boucle

% Dtermination de la valeur finale de l'intgrale
I=h.*somme./3;
end
