function t=student(N,r)

% Fournit le coefficient de Student correspondant aux nombres de valeurs
% exprimentales. 
% Le coefficient corrige selon une approche statistique l'cart-type, en
% augmentant la confiance pour un grand nombre de mesure

% ddl : degrs de libert (=N-r-1)

S(1)=12.706; % nb de ddl=2
S(2)=4.303;  % nb de ddl=3
S(3)=3.181;  % ...
S(4)=2.776;
S(5)=2.571;
S(6)=2.447;
S(7)=2.365;
S(8)=2.306;
S(9)=2.262;
S(10)=2.228;
S(11)=2.201;
S(12)=2.179;
S(13)=2.160;
S(14)=2.145;
S(15)=2.131;
S(16)=2.120;
S(17)=2.110;
S(18)=2.101;
S(19)=2.093;
S(20)=2.086;
S(21)=2.080;
S(22)=2.074;
S(23)=2.069;
S(24)=2.064;
S(25)=2.060;
S(26)=2.056;
S(27)=2.052;
S(28)=2.048;
S(29)=2.045;
S(30)=2.042;
S(31)=1.960; % nb de ddl=infini

% Si N-r-1 est suprieur  30, on prendra
% l'indice 1.960 (inf).
if (N-r-1)<31
    t=S(N-r-2);
else t=S(31);

end



