function w=adiab(p1,V1,p2,V2)
% La fonction calcule le travail correspondant  une transformation
% adiabatique (d'un gaz parfait diatomique), entre les tats 1 et 2, 
% caractriss par leur pression p et volume V.

% W=Cv/Rx(p2*V2-p1*V1) avec Cv/r=5/2=2.5 pour un gaz parfait diatomique
w=2.5*(p2*V2-p1*V1);
end