% Script ouvrant une bote de dialogue, organisant l'entre des
% valeurs de pression et de volume. L'utilisateur est guid
% par le diagramme de Clapeyron qui lui est prsent juste
% auparavant.

% Ouverture de la bote de dialogue, dfinition des champs
prompt={['pA'],['pB'],['pC'],['pD'],['VA'],['VB'],['VC'],['VD']};

% Dfinition du titre de la bote de dialogue
title=['Veuillez entrer...'];

% Definition des valeurs par dfaut de chaque champ, on y affiche les
% units des valeurs dsires
defAns={'(en Bar)','(en Bar)','(en Bar)','(en Bar)','(en m^3)',...
    '(en m^3)','(en m^3)','(en m^3)'};

% Champ rgl  une seule ligne
lineNo=1;

% Cration d'un matrice reponse qui contiendra les 
% valeurs entres par l'utilisateur
reponse = inputdlg(prompt,title,lineNo,defAns);

% Assignation au variables des valeurs donnes par
% l'utilisateur.
pA=str2num(reponse{1})*100000; % On effectue la conversion Bars/Pascals
pB=str2num(reponse{2})*100000;
pC=str2num(reponse{3})*100000;
pD=str2num(reponse{4})*100000;
VA=str2num(reponse{5});
VB=str2num(reponse{6});
VC=str2num(reponse{7});
VD=str2num(reponse{8});
